import sys

FileName1 = sys.argv[1]
FileName2 = sys.argv[2]
Name1 = FileName1
Name2 = FileName2
if len(sys.argv) > 4:
	Name1 = sys.argv[3]
if len(sys.argv) > 4:
	Name2 = sys.argv[4]

ACGT = ( "A", "C", "G", "T" )
ACGTN = ( "A", "C", "G", "T", "N" )

def GetCounts(FileName):
	One = {}
	Two = {}

	for c in ACGT:
		One[c] = 0
		for d in ACGT:
			Two[c + d] = 0
	
	File = open(FileName)
	Lastc = ""
	while 1:
		Line = File.readline()
		if len(Line) == 0:
			break
		if Line[0] == ">":
			continue
		Line = Line.upper()
		s = ""
		for c in Line:
			c = c.upper()
			if c not in ACGT:
				continue
			s += c
			One[c] += 1
			if Lastc != "":
				Two[Lastc + c] += 1
			Lastc = c
	return One, Two

An1, An2 = GetCounts(FileName1)
Ev1, Ev2 = GetCounts(FileName2)

AnBases = 0
EvBases = 0
for c in ACGT:
	AnBases += An1[c]
	EvBases += Ev1[c]

print ""

print "Letter  %10.10s     Pct  %10.10s     Pct      dBases    dPct" % (Name1, Name2)
print "======  ==========  ======  ==========  ======  ==========  ======"
for c in ACGT:
	AnPct = 100*float(An1[c])/float(AnBases)
	EvPct = 100*float(Ev1[c])/float(EvBases)
	print "%6c  %10u  %5.1f%%  %10u  %5.1f%%  %+10d  %+5.1f%%" % (c, An1[c], AnPct, Ev1[c], EvPct, Ev1[c] - An1[c], EvPct - AnPct)

print ""

AnATBases = An1["A"] + An1["T"]
AnCGBases = An1["G"] + An1["C"]
EvATBases = Ev1["A"] + Ev1["T"]
EvCGBases = Ev1["G"] + Ev1["C"]

AnTotal1 = AnATBases + AnCGBases
EvTotal1 = EvATBases + EvCGBases

AnATPct = 100*float(AnATBases)/float(AnBases)
AnCGPct = 100*float(AnCGBases)/float(AnBases)

EvATPct = 100*float(EvATBases)/float(EvBases)
EvCGPct = 100*float(EvCGBases)/float(EvBases)

def GetPct(x, y):
	if y == 0:
		return 0
	return x*100.0/y

print "   A+T  %10u  %5.1f%%  %10u  %5.1f%%  %+10d  %+5.1f%%" % (AnATBases, AnATPct, EvATBases, EvATPct, EvATBases - AnATBases, EvATPct - AnATPct)
print "   G+C  %10u  %5.1f%%  %10u  %5.1f%%  %+10d  %+5.1f%%" % (AnCGBases, AnCGPct, EvCGBases, EvCGPct, EvCGBases - AnCGBases, EvCGPct - AnCGPct)
print ""
print " Total  %10u  %5.1f%%  %10u  %5.1f%%  %+10d  %+5.1f%%" % (AnTotal1, AnCGPct, EvTotal1, EvCGPct, EvTotal1 - AnTotal1, GetPct(EvTotal1 - AnTotal1, AnTotal1))

AnTotal2 = 0
EvTotal2 = 0
print ""
print " Dinuc  %10.10s     Pct  %10.10s     Pct         dNr    dPct" % (Name1, Name2)
print "======  ==========  ======  ==========  ======  ==========  ======"
for c in ACGT:
	for d in ACGT:
		e = c + d
		AnTotal2 += An2[e]
		EvTotal2 += Ev2[e]
		AnPct = (100.0*An2[e])/(AnBases - 1)
		EvPct = (100.0*Ev2[e])/(EvBases - 1)
		print "%6s  %10u  %5.1f%%  %10u  %5.1f%%  %+10d  %+5.1f%%" % (e, An2[e], AnPct, Ev2[e], EvPct, Ev2[e] - An2[e], EvPct - AnPct)

print ""
